/* Copyright (C) Sami Ojanen 2008 */
import ral.Real;
import java.util.Vector;
public class CalcAttrAndFnc extends Calc {

	protected Real r=null;
	protected String attrbs=null;
	protected int numOfParameters=0;
	protected Calc func=null;

	public CalcAttrAndFnc(Real x,String s) {
		r=new Real(x);
		attrbs=s;
	}

	public CalcAttrAndFnc(long x,String s) {
		r=new Real(x);
		attrbs=s;
		//System.out.println(r);
		//System.out.println(rs);
	}

	public CalcAttrAndFnc(String attrname,Calc cl,int parameters) {
		attrbs=attrname;
		numOfParameters=parameters;
		if(parameters==0) {
			r=cl.eval(null);
		} else {
			func=cl;
		}
	}

	public CalcAttrAndFnc(CalcAttrAndFnc fnc) {
		r=fnc.r;
		attrbs=fnc.attrbs;
		numOfParameters=fnc.numOfParameters;
		func=fnc.func;
	}

	public Calc getNewObject() {
		//System.out.println("Number.getNewObject");
		CalcAttrAndFnc c = new CalcAttrAndFnc(this);
		//System.out.println(c.r);
		//System.out.println(c.rs);
		//System.out.println(c.sign);
		
		return (Calc)c;
	}

	public Calc getFunc() {
		return func;
	}

	public int getEvalPriority() {
		return 1;
	}

	public int assignCalc(Calc c) {
		Calc idx=c;
		while (idx!=null) {
			if(idx.toString().equals(attrbs)) return -1;
			idx=idx.nextCalc();
		}
		func=c;
		return c==null?0:1;
	}

	public void assignr(Real x) {
		r.assign(x);
	}

	public int numOfParameters() {
		return numOfParameters;
	}

	public Real eval(Vector parameters) {
		CalcTreeNode tree=null;
		Calc c=null;
		Real lastResult=null;
		if((parameters==null)&&(numOfParameters==0)) return r;
		else if(parameters.size()==numOfParameters) {
			if(numOfParameters==0) return r;
			else {
				c=func;
				while (c!=null) {
					if(c.toString().equals("X")) 
						((CalcAttrAndFnc)c).assignr((Real)(parameters.elementAt(0)));
					if(c.toString().equals("Y")&&(numOfParameters>=2)) 
						((CalcAttrAndFnc)c).assignr((Real)(parameters.elementAt(0)));
					c=c.nextCalc();
				}



				if(func!=null) c=func.nextCalc();
				else c=null;
				tree=null;
				try {
					tree=new CalcTreeNode(null,null,func.getNewObject());
					while((c!=null)&&(tree!=null)) {
						tree=tree.addCalcToTree(c.getNewObject());
						c=c.nextCalc();
					}
					if(tree!=null) {
						c=null;
						lastResult=tree.wholeTreeEval();
					}
				} catch (Exception e) {
					tree=null;
				}
				if(tree==null) {
					return null;
					
				}
				else if((c==null)&&(lastResult!=null)) {
					//System.out.println("result="+lastResult);
					//setRealToCalculations(lastResult);
					return lastResult;
				} else { ;
					/*cursor=null;
					calculations=null;
					errstr="Error";*/
				}
			}
		}
		return null;
	}

	public Real getReal() {
		return r;
	}

	public String toString() {
		return attrbs;
//		if(rs.charAt(rs.length()-1)=='.') return r.toString()+'.';
//		else return r.toString();
	}
}

