/* Copyright (C) Sami Ojanen 2008 */
import ral.Real;
import java.util.Vector;
public class CalcBiOperator extends Calc {

	protected String operator=null;
	protected int evalpriority=3;

	public CalcBiOperator(String s) {
		operator=s;
		if(s.equals("+")||s.equals("-")) evalpriority=5;
		else if(s.equals("x")||s.equals("/")||s.equals("mod")) evalpriority=4;
		//System.out.println(evalpriority);
		//System.out.println(operator);
	}

	public Calc getNewObject() {
		//System.out.println("BiOperator.getNewObject");
		CalcBiOperator c = new CalcBiOperator(operator);
		return (Calc)c;
	}

	public int getEvalPriority() {
		return evalpriority;
	}

	public int numOfParameters() {
		return 2;
	}

	public Real eval(Vector parameters) {
		Real r1,r2;
		Real r3;
		if(parameters.size()!=2) return null;
		else {
			//System.out.println(operator);
			r1=(Real)parameters.elementAt(0);
			r2=(Real)parameters.elementAt(1);
			if(operator.equals("+")) {
				r1.add(r2);
				return r1;
			}
			if(operator.equals("-")) {
				r1.sub(r2);
				return r1;
			}
			if(operator.equals("x")) {
				r1.mul(r2);
				return r1;
			}
			if(operator.equals("/")) {
				r1.div(r2);
				return r1;
			}
			if(operator.equals("mod")) {
				r1.mod(r2);
				return r1;
			}
			if(operator.equals("nroot")) {
				r1.nroot(r2);
				return r1;
			}
			if(operator.equals("^")) {
				r1.pow(r2);
				return r1;
			}
			if(operator.equals("hypot")) {
				r1.hypot(r2);
				return r1;
			}
		}
		return null;
	}

	public String toString() {
		return operator;
//		if(rs.charAt(rs.length()-1)=='.') return r.toString()+'.';
//		else return r.toString();
	}
}

