/* Copyright (C) Sami Ojanen 2008 */
import java.util.Vector;
import ral.Real;

public class CalcNumber extends Calc {

	protected Real r=null;
	protected String rs=null;
	protected char sign='+';

	public CalcNumber(Real x,String s) {
		if(s==null) s="0";
		if(s.equals("")) s="0";
		if(s.equals("+/-")) {
			sign='-';
			rs="0";
			r=new Real(0);
		} else if(s.equals(".")) {
			r=new Real(0);
			rs="0.";
		} else {
			r=new Real(x);
			if(s.charAt(0)=='-') {
				rs=s.substring(1);
				sign='-';
			} else rs=new String(s);
			if(rs.equals("")) rs="0";
		}
	}

	public CalcNumber(long x,String s) {
		r=new Real(x);
		rs=new String(s);
		//System.out.println(r);
		//System.out.println(rs);
	}

	public CalcNumber(CalcNumber cl) {
		this.r=new Real(cl.r);
		this.rs=new String(cl.rs);
		this.sign=cl.sign;
		if(rs.equals("+/-")) {
			sign='-';
			rs="0";
			r=new Real(0);
		} else if(rs.equals(".")) {
			r=new Real(0);
			rs="0.";
		}
	}

	public Calc getNewObject() {
		//System.out.println("Number.getNewObject");
		CalcNumber c = new CalcNumber(this);
		//System.out.println(c.r);
		//System.out.println(c.rs);
		//System.out.println(c.sign);
		
		return (Calc)c;
	}

	public Calc addNextCalc(Calc cursor) {
		CalcNumber cl=null;
		try {
			cl=(CalcNumber)cursor;
		} catch (Exception e) {
			cl=null;
		}
		if (cl==null) {
			//System.out.println("Super");
			return super.addNextCalc(cursor);
		}
		cl.addNumberToEnd(this.rs);
		return cl;
	}

	public void addNumberToEnd(String s) {
		String ss="";
		if(rs==null) rs=r.toString();
		if(s.equals(".")) {
			for(int i=0;i<rs.length();i++) 
				if (rs.charAt(i)=='.') s=null;
				else ss=ss+rs.charAt(i);
			if(s==null) {
				rs=ss;
				if(sign=='-') r=new Real("-"+rs);
				else r=new Real(rs);
			} else {
				rs=ss+".";
				if(sign=='-') r=new Real("-"+rs+"0");
				else r=new Real(rs+"0");
			}
		} else if(s.equals("+/-")) {
			//System.out.println("+/- tuli"+(new Character(sign)).toString());
			if(sign=='-') {
				sign='+';
				r=new Real(rs);
			}
			else {
				sign='-';
				r=new Real("-"+rs);
			}
		} else {
			rs=rs+s;
			if (sign=='-') 
				r=new Real("-"+rs);
			else r=new Real(rs);
		}
	}

	public int getEvalPriority() {
		return 0;
	}

	public int numOfParameters() {
		return 0;
	}

	public Real eval(Vector parameters) {
		//System.out.println(r.toString());
		if(parameters==null) return r;
		else if(parameters.size()==0) return r;
		else return null;
	}

	public Real getReal() {
		return r;
	}

	public String toString() {
		boolean keeplooping=true;
		if(rs.length()>1) {
			while (keeplooping) {
				keeplooping=false;
				//System.out.println(rs.substring(0,1));
				if(rs.charAt(0)=='0')
					if(rs.charAt(1)!='.') {
						keeplooping=true;
						rs=rs.substring(1);
				}
				if(rs.length()<2) keeplooping=false;
			}
		}
		if(sign=='-') return "-"+rs;
		else return rs;
//		if(rs.charAt(rs.length()-1)=='.') return r.toString()+'.';
//		else return r.toString();
	}
}

