/* Copyright (C) Sami Ojanen 2008 */
import java.util.Vector;
import ral.Real;

public class CalcTreeNode extends Object {
	Calc node = null;
	Vector children = null;
	int numOfParentheses = 0;
	CalcTreeNode parent = null;
	boolean haveFreeChild = true;

	public boolean getHaveFreeChild() {
		return haveFreeChild;
	}

	public CalcTreeNode addCalcToTree(Calc c) {
		CalcTreeNode ct=null;
		//System.out.println("c="+c.toString()+", node="+node.toString());
		if(node.toString().equals(")")) 
			if(parent!=null) return parent.addCalcToTree(c);
			else {
				ct=new CalcTreeNode(null,this,c);
				this.parent=ct;
				return ct;
			}
		if(c.toString().equals(")")) {
			//if(node.toString().equals("(")) return null;
			if(node.toString().equals("(")) {
				ct=new CalcTreeNode(parent,this,c);
				if(parent!=null) parent.children.setElementAt(ct,parent.children.size()-1);
				return ct;
			} else return parent.addCalcToTree(c);
		}
		if(c.toString().equals("(")) {
			ct=new CalcTreeNode(this,null,c);
			children.insertElementAt(ct,children.size());
			return ct;
		}
		if(node.toString().equals("(")) {
			if(children==null) children=new Vector();
			if(children.size()>0) {
				ct=new CalcTreeNode(this,(CalcTreeNode)(children.elementAt(children.size()-1)),c);
				children.setElementAt(ct,children.size()-1);
				return ct;
			} else {
				ct=new CalcTreeNode(this,null,c);
				children.insertElementAt(ct,0);
				return ct;
			}
		}
		if(node.getEvalPriority()==c.getEvalPriority()) {
			//System.out.println("node.priority==c.priority");
			if(node.numOfParameters()>=2) {
				//System.out.println("2-parameters");
				ct=new CalcTreeNode(parent,this,c);
				if(parent!=null) parent.children.setElementAt(ct,parent.children.size()-1);
				this.parent=ct;
				return ct;
			} else {
				//System.out.println("1-parameters");
				if(this.children.size()==0) {
					ct=new CalcTreeNode(this,null,c);
					children.insertElementAt(ct,0);
					return ct;
				} else {
					ct=new CalcTreeNode(this,(CalcTreeNode)(children.elementAt(0)),c);
					children.setElementAt(ct,0);
					return ct;
				}
			}
		} else if(node.getEvalPriority()>c.getEvalPriority()) {
			//System.out.println("Node.priority>c.priority");
			//System.out.println(node.numOfParameters());
			//System.out.println(children.size());
			if(node.numOfParameters()>children.size()) {
				// Lisätään Uusi lapsi
				//System.out.println("addchild, size()=");
				//System.out.println(children.size());
				ct=new CalcTreeNode(this,null,c);
				children.insertElementAt(ct,children.size());
				return ct;
			} else if(node.numOfParameters()>=2) {
				//System.out.println("addchild when have both children");
				ct=new CalcTreeNode(this,(CalcTreeNode)(children.elementAt(children.size()-1)),c);
				children.setElementAt(ct,children.size()-1);
				return ct;
			} else if(node.numOfParameters()==1) {
				if(children.size()>0) return ((CalcTreeNode)(children.elementAt(0))).addCalcToTree(c);
				else return null;
			} else {
				if(node.toString().equals(")"))
					if(parent!=null) return parent.addCalcToTree(c);
				return null;
			}
		} else { // node.getEvalPriority()<c.getEvalPriority()
			//System.out.println("node.priority<c.priority");
			if(parent!=null) return parent.addCalcToTree(c);
			else {
				ct=new CalcTreeNode(null,this,c);
				this.parent=ct;
				return ct;
			}
		}
		//return null;
	}

	public CalcTreeNode(CalcTreeNode prent,CalcTreeNode firstChild,Calc c) {
		parent=prent;
		children = new Vector();
		if(firstChild!=null) {
			children.insertElementAt(firstChild,0);
		} 
		/*if(prent!=null) 
			if(prent.children.elementAt(0)==firstChild)
				prent.children.setElementAt(this,0);*/
		node=c;
	}

	public Real wholeTreeEval() {
		CalcTreeNode root = this;
		while (root.parent!=null) root=root.parent;
		return root.eval();
	}

	public Real eval() {
		Vector v;
		if(children==null) {
			//System.out.println("node.eval(null)");
			return node.eval(null);
		}
		else {
			v=new Vector();
			for(int i=0;i<children.size();i++) {
				v.insertElementAt(((CalcTreeNode)children.elementAt(i)).eval(),v.size());
			}
			//System.out.println("node.eval(v)"+node.toString());
			//System.out.println(v.size());
			return node.eval(v);
		}
	}
}
